'use strict';Object.defineProperty(exports,'__esModule',{value:true});var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;if('value'in descriptor)descriptor.writable=true;Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){if(protoProps)defineProperties(Constructor.prototype,protoProps);if(staticProps)defineProperties(Constructor,staticProps);return Constructor}}();var _Input=require('./Input');var _Input2=_interopRequireDefault(_Input);var _ReservedKeywords=require('../../lang/ReservedKeywords.json');var _ReservedKeywords2=_interopRequireDefault(_ReservedKeywords);var _Token=require('./Token');var _Token2=_interopRequireDefault(_Token);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor)){throw new TypeError('Cannot call a class as a function')}}var Lexer=function(){function Lexer(input){_classCallCheck(this,Lexer);if(!(input instanceof _Input2.default)){throw new TypeError('Argument "input" must be an instance of type "Input".')}this.currentToken=null;this.input=input}_createClass(Lexer,[{key:'eof',value:function eof(){return this.input.eof()}},{key:'inputError',value:function inputError(message){this.input.error(message)}},{key:'next',value:function next(){var token=this.currentToken;this.currentToken=null;return token||this.nextToken()}},{key:'nextToken',value:function nextToken(){this.readWhile(Lexer.isWhitespace);if(this.input.eof()){return null}var char=this.input.peek();if('#'===char){this.skipComment();return this.nextToken()}if(Lexer.isString(char)){return this.readString()}if(Lexer.isDigit(char)){return this.readNumber()}if(Lexer.isIdentifierStart(char)){return this.readIdentifier()}if(Lexer.isOperation(char)){return this.readOperation()}if(Lexer.isPunctuation(char)){return this.readPunctuation()}return this.inputError('Invalid character')}},{key:'peek',value:function peek(){return this.currentToken||this.next()}},{key:'readEscaped',value:function readEscaped(end){var escaped=false,str='';while(!this.input.eof()){var char=this.input.next();if(escaped){str+=char;escaped=false}else if('\\'===char){escaped=true}else if(char===end){this.input.next();break}else{str+=char}}return str}},{key:'readIdentifier',value:function readIdentifier(){var identifier=this.input.peek().concat(this.readWhile(function(char){return Lexer.isIdentifier(char)})).trim();return new _Token2.default(Lexer.isReservedKeyword(identifier)?'keyword':'identifier',identifier)}},{key:'readNumber',value:function readNumber(){var isDecimal=false;var number=this.input.peek().concat(this.readWhile(function(char){if('.'===char){if(isDecimal){return false}isDecimal=true;return true}return Lexer.isDigit(char)})).trim();return new _Token2.default('numeric',parseFloat(number))}},{key:'readOperation',value:function readOperation(){return new _Token2.default('operation',this.input.peek().concat(this.readWhile(function(char){return Lexer.isOperation(char)})).trim())}},{key:'readPunctuation',value:function readPunctuation(){return new _Token2.default('punctuator',this.input.peek())}},{key:'readString',value:function readString(){return new _Token2.default('string',this.readEscaped('"'))}},{key:'readWhile',value:function readWhile(callback){var str='';while(!this.input.eof()&&callback(this.input.peek())){str+=this.input.next()}return str}},{key:'skipComment',value:function skipComment(){this.readWhile(function(char){return'\n'!==char});this.input.next()}}],[{key:'isDigit',value:function isDigit(char){return /[0-9]/.test(char)}},{key:'isIdentifier',value:function isIdentifier(char){return Lexer.isIdentifierStart(char)||/[a-zA-Z_]/.test(char)}},{key:'isIdentifierStart',value:function isIdentifierStart(char){return /[a-zA-Z]/.test(char)}},{key:'isOperation',value:function isOperation(char){return-1!=='+-*/%=&|<>!'.indexOf(char)}},{key:'isPunctuation',value:function isPunctuation(char){return-1!==',;(){}[]'.indexOf(char)}},{key:'isReservedKeyword',value:function isReservedKeyword(char){return-1!==_ReservedKeywords2.default.indexOf(char)}},{key:'isString',value:function isString(char){return'"'===char}},{key:'isWhitespace',value:function isWhitespace(char){return /\s/.test(char)}}]);return Lexer}();exports.default=Lexer;