'use strict';Object.defineProperty(exports,'__esModule',{value:true});var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;if('value'in descriptor)descriptor.writable=true;Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){if(protoProps)defineProperties(Constructor.prototype,protoProps);if(staticProps)defineProperties(Constructor,staticProps);return Constructor}}();var _Lexer=require('../Lexer');function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor)){throw new TypeError('Cannot call a class as a function')}}var Parser=function(){function Parser(lexer){_classCallCheck(this,Parser);if(!(lexer instanceof _Lexer.Lexer)){throw new TypeError('Argument "lexer" must be an instance of type "Lexer".')}this.lexer=lexer;this.syntaxTree=[];this.syntaxTreeIndex=0}_createClass(Parser,[{key:'getLastNode',value:function getLastNode(){return'undefined'!==typeof this.syntaxTree[this.syntaxTreeIndex-1]?this.syntaxTree[this.syntaxTreeIndex-1]:null}},{key:'parse',value:function parse(){while(!this.lexer.eof()){var token=this.lexer.next();if(!(token instanceof _Lexer.Token)){continue}if(Parser.isTrigger(token)){this.pushNodeToSyntaxTree(this.parseTrigger())}if(Parser.isResponse(token)&&'trigger'===this.getLastNode().type){this.getLastNode().responses.push(this.parseResponse())}}return{type:'program',body:this.syntaxTree}}},{key:'parseTrigger',value:function parseTrigger(){var trigger=this.lexer.next();var pattern='';if('string'!==trigger.getType()){return this.lexer.inputError('Expected trigger pattern after trigger identifier.')}pattern=Parser.replaceWildcard(trigger.getValue());pattern=Parser.replaceStringSubstitution(pattern);return{type:'trigger',src:trigger.getValue(),pattern:pattern,responses:[]}}},{key:'parseResponse',value:function parseResponse(){var response=this.lexer.next();if('string'!==response.getType()){this.lexer.inputError('Expected string after response identifier.')}return{type:'response',value:response.getValue()}}},{key:'pushNodeToSyntaxTree',value:function pushNodeToSyntaxTree(node){this.syntaxTreeIndex+=1;this.syntaxTree.push(node)}}],[{key:'isResponse',value:function isResponse(token){return token instanceof _Lexer.Token&&'operation'===token.getType()&&'-'===token.getValue()}},{key:'isTrigger',value:function isTrigger(token){return token instanceof _Lexer.Token&&'operation'===token.getType()&&'+'===token.getValue()}},{key:'replaceStringSubstitution',value:function replaceStringSubstitution(string){return string.replace(/(\s?)\$(\s?)/g,'\\s?(\\w+?)\\s?')}},{key:'replaceWildcard',value:function replaceWildcard(string){return string.replace(/(\s?)\*(\s?)/g,'(\\w?)')}}]);return Parser}();exports.default=Parser;